function [count, short] = lengthpath(m,n,r)

% This function checks the length of the constructed path and compares it 
% to the shortest length.


% Calculate the length of the constructed path:
if r == 0 || r == 1
        if n < m
           c = n;
           n = m;
           m = c;
        end
end

if r == 0
    A = numbering_matrix_zero(m,n);
elseif r == 1
    if ( m == 1 && n <= 4 ) || ( m == 2 && n <= 2)
        errordlg('There do not exist feasible tours for this dimensions');
    elseif (m == 1) || (m == 2) || (m == 4)
        A = numbering_matrix_one_specialcases(m,n);
    elseif mod(m,2)==1 && mod(n,2)==1
        A = numbering_matrix_one_oddodd(m,n);
    else
        A = numbering_matrix_one(m,n);
    end
elseif r == 2
    if (m == 1 && n < 5) || (m == 2) || (m == 3 && n < 4)
        errordlg('There does not exist a feasible tour for this dimension!');
    else
        A = numbering_matrix_sr2(m,n);
    end
else
    errordlg('r has to be 0, 1 or 2!')
end


count = 0;

[a,b] = find(A==1);

for i = 2:m*n,
    [row,col] = find(A == i);
    if (row == a+1 && col == b) || (row == a-1 && col == b) || (row == a && col == b+1) || (row == a && col == b-1)
        count = count+1;
        a=row;
        b=col;
    elseif (row==a+1 && col==b+1) || (row==a-1 && col==b+1) || (row==a+1 && col==b-1) || (row==a-1 && col==b-1)
        count = count+sqrt(2);
        a=row;
        b=col;
    elseif (row==a+2 && col==b) || (row==a-2 && col==b) || (row==a && col==b-2) || (row==a && col==b+2)
        count = count+2;
        a=row;
        b=col;
    elseif (row==a+2 && col==b+1) || (row==a+2 && col==b-1) || (row==a+1 && col==b+2) || (row==a+1 && col==b-2) || (row==a-1 && col==b+2) || (row==a-1 && col==b-2) || (row==a-2 && col==b+1) || (row==a-2 && col==b-1)
        count = count+sqrt(5);
        a=row;
        b=col;
    elseif (row==a && col==b+3) || (row==a && col==b-3) || (row==a+3 && col==b) || (row==a-3 && col==b)
        count = count+3;
        a=row;
        b=col;
    elseif (row==a && col==b+4) || (row==a && col==b-4) || (row==a+4 && col==b) || (row==a-4 && col==b)
        count = count+4;
            a=row;
            b=col;
    elseif (row==a && col==b+5) || (row==a && col==b-5) || (row==a+5 && col==b) || (row==a-5 && col==b)
        count = count+5;
            a=row;
            b=col;
    end
end

if r == 0 && m == 1
    count = count+(n-1);
else
    [row,col] = find(A==1);
    if (row==(a+1) && col==b) || (row==(a-1) && col==b) || (row==a && col==(b+1)) || (row==a && col==(b-1))
        count = count+1;
    elseif (row==a+1 && col==b+1) || (row==a-1 && col==b+1) || (row==a+1 && col==b-1) || (row==a-1 && col==b-1)
        count = count+sqrt(2);
    elseif (row==a+2 && col==b) || (row==a-2 && col==b) || (row==a && col==b-2) || (row==a && col==b+2)
        count = count+2;
    elseif (row==a+2 && col==b+1) || (row==a+2 && col==b-1) || (row==a+1 && col==b+2) || (row==a+1 && col==b-2) || (row==a-1 && col==b+2) || (row==a-1 && col==b-2) || (row==a-2 && col==b+1) || (row==a-2 && col==b-1)
        count = count+sqrt(5);
    elseif (row==a && col==b+3) || (row==a && col==b-3) || (row==a+3 && col==b) || (row==a-3 && col==b)
        count = count+3;
    elseif (row==a && col==b+4) || (row==a && col==b-4) || (row==a+4 && col==b) || (row==a-4 && col==b)
        count = count+4;
    end
end


% The shortest length depends on the dimensions of A:

if r == 0
    if m == 1
        short = 2*(n-1);
    elseif mod(m,2) == 0 || mod(n,2) == 0
        short = m*n;
    elseif mod(m,2) == 1 && mod(n,2) == 1 && m >= 3
        short = m*n-1+sqrt(2);
    end
elseif r == 1
    if mod(m,2) == 0 && m >= 6
        short = m*(n-1)*sqrt(2)+2*(m-2)+2*sqrt(5);
    elseif mod(m,2) == 1 && m >= 5 && m ~= n
        short = n*(m-1)*sqrt(2)+2*(n-2)+2*sqrt(5);
    elseif mod(m,2) == 1 && m >= 5 && m ==n
        short = (m^2-m-1)*sqrt(2)+2*(m-1)+2*sqrt(5);
    elseif m == 3 && n >= 4
        short = 2*n*sqrt(2)+2*(n-2)+2*sqrt(5);
    elseif m == 3 && m == 3
        short = 5*sqrt(2)+4+2*sqrt(5);
    elseif m == 1 %Start with special cases lemma 7:
        if n == 5
            short = 12;
        elseif n == 6
            short = 16;
        elseif n >= 7
            short = 2*n+6;
        end
    elseif m == 2 
        if n == 3
            short = 4*sqrt(2)+2*sqrt(5);
        elseif n == 4
            short = 4*sqrt(2)+4+2*sqrt(5);
        elseif n == 5
            short = 4*sqrt(2)+8+2*sqrt(5);
        elseif n >= 6
            short = (2*n-6)*sqrt(2)+4*2+2*sqrt(5);
        end
    elseif m == 4
        short = (4*n-5)*sqrt(2)+3*2+2*sqrt(5);
    end
elseif r == 2
    if m == 3
        short = 2*(3*n-6)+6*sqrt(5);
    elseif m >= 4
        short = 2*(m*n-4)+4*sqrt(5);
    end
end